(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Ticket_hash_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_address.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_qty.

Module deposit.
  Record record : Set := Build {
    destination : Tx_rollup_l2_address.Indexable.value;
    ticket_hash : Ticket_hash_repr.t;
    amount : Tx_rollup_l2_qty.t }.
  Definition with_destination destination (r : record) :=
    Build destination r.(ticket_hash) r.(amount).
  Definition with_ticket_hash ticket_hash (r : record) :=
    Build r.(destination) ticket_hash r.(amount).
  Definition with_amount amount (r : record) :=
    Build r.(destination) r.(ticket_hash) amount.
End deposit.
Definition deposit := deposit.record.

Definition deposit_encoding : Data_encoding.encoding deposit :=
  (let arg :=
    Data_encoding.conv
      (fun (function_parameter : deposit) =>
        let '{|
          deposit.destination := destination;
            deposit.ticket_hash := ticket_hash;
            deposit.amount := amount
            |} := function_parameter in
        (destination, ticket_hash, amount))
      (fun (function_parameter :
        Tx_rollup_l2_address.Indexable.value * Ticket_hash_repr.t *
          Tx_rollup_l2_qty.t) =>
        let '(destination, ticket_hash, amount) := function_parameter in
        {| deposit.destination := destination;
          deposit.ticket_hash := ticket_hash; deposit.amount := amount |}) in
  fun (eta :
    Data_encoding.encoding
      (Tx_rollup_l2_address.Indexable.value * Ticket_hash_repr.t *
        Tx_rollup_l2_qty.t)) => arg None eta)
    (Data_encoding.obj3
      (Data_encoding.req None None "destination"
        Tx_rollup_l2_address.Indexable.value_encoding)
      (Data_encoding.req None None "ticket_hash" Ticket_hash_repr.encoding)
      (Data_encoding.req None None "amount" Tx_rollup_l2_qty.encoding)).

Inductive t : Set :=
| Batch : string -> t
| Deposit : deposit -> t.

Definition encoding : Data_encoding.encoding t :=
  Data_encoding.union (Some (Variant.Build "Uint8" unit tt))
    [
      Data_encoding.case_value "Batch" None (Data_encoding.Tag 0)
        (Data_encoding.obj1
          (Data_encoding.req None None "batch" Data_encoding.string_value))
        (fun (function_parameter : t) =>
          match function_parameter with
          | Batch batch => Some batch
          | _ => None
          end) (fun (batch : string) => Batch batch);
      Data_encoding.case_value "Deposit" None (Data_encoding.Tag 1)
        (Data_encoding.obj1
          (Data_encoding.req None None "deposit" deposit_encoding))
        (fun (function_parameter : t) =>
          match function_parameter with
          | Deposit deposit => Some deposit
          | _ => None
          end) (fun (deposit : deposit) => Deposit deposit)
    ].

Axiom pp : Format.formatter -> t -> unit.

Definition size_value (function_parameter : t) : int :=
  match function_parameter with
  | Batch batch => String.length batch
  |
    Deposit {|
      deposit.destination := d_value;
        deposit.ticket_hash := _;
        deposit.amount := _
        |} =>
    let destination_size := Tx_rollup_l2_address.Indexable.size_value d_value in
    let key_hash_size := 32 in
    let amount_size := 8 in
    (destination_size +i key_hash_size) +i amount_size
  end.

Definition hash_size : int := 32.

Definition Message_hash :=
  Blake2B.Make
    {|
      Blake2B.Register.register_encoding _ := Base58.register_encoding
    |}
    (let name := "Tx_rollup_inbox_message_hash" in
    let title := "The hash of a transaction rollup inbox\226\128\153s message"
      in
    let b58check_prefix := "\002U" in
    let size_value := Some hash_size in
    {|
      Blake2B.PrefixedName.name := name;
      Blake2B.PrefixedName.title := title;
      Blake2B.PrefixedName.size_value := size_value;
      Blake2B.PrefixedName.b58check_prefix := b58check_prefix
    |}).

(** Init function; without side-effects in Coq *)
Definition init_module_repr : unit :=
  Base58.check_encoded_prefix Message_hash.(S.HASH.b58check_encoding) "M" 51.

Definition hash : Set := Message_hash.(S.HASH.t).

Definition pp_hash : Format.formatter -> Message_hash.(S.HASH.t) -> unit :=
  Message_hash.(S.HASH.pp).

Definition hash_encoding : Data_encoding.t Message_hash.(S.HASH.t) :=
  Message_hash.(S.HASH.encoding).

Definition hash_uncarbonated (msg : t) : Message_hash.(S.HASH.t) :=
  Message_hash.(S.HASH.hash_bytes) None
    [ Data_encoding.Binary.to_bytes_exn None encoding msg ].

Definition hash_equal
  : Message_hash.(S.HASH.t) -> Message_hash.(S.HASH.t) -> bool :=
  Message_hash.(S.HASH.equal).
